//
//  Scanbot Barcode Scanner SDK Flutter Plugin
//
//  Copyright (c) 2020 doo GmbH. All rights reserved.
//  https://scanbot.io/sdk
//

import Foundation
import ScanbotBarcodeScannerSDK

extension SBSDKUIBarcodeScannerBehaviorConfiguration {
    convenience init(from dictionary: [String: Any]) {
        self.init()
        
        if let flashEnabled = dictionary["flashEnabled"] as? Bool {
            self.isFlashEnabled = flashEnabled
        }
        
        if let autoCancelTimeout = dictionary["autoCancelTimeout"] as? Double {
            self.autoCancelTimeout = autoCancelTimeout
        }
        
        if let successBeepEnabled = dictionary["successBeepEnabled"] as? Bool {
            self.isSuccessBeepEnabled = successBeepEnabled
        }
        
        if let value = dictionary["barcodeImageGenerationType"] as? String {
            let barcodeImageGenerationType = SBSDKBarcodeImageGenerationType(from: value)
            self.barcodeImageGenerationType = barcodeImageGenerationType
        }
        
        if let value = dictionary["additionalParameters"] as? [String: Any] {
            let additionalParameters = SBSDKBarcodeAdditionalParameters(from: value)
            self.additionalParameters = additionalParameters
        }
        
        if let focusLockEnabled = dictionary["minFocusDistanceLock"] as? Bool {
            self.isFocusLockEnabled = focusLockEnabled
        }
        
        if let engineMode = SBSDKBarcodeEngineMode.fromArguments(dictionary) {
            self.engineMode = engineMode
        }
        
        if let cameraZoomFactor = dictionary["cameraZoomFactor"] as? CGFloat {
            self.cameraZoomFactor = cameraZoomFactor
        }
    }
}
