//
//  Scanbot Barcode Scanner SDK Flutter Plugin
//
//  Copyright (c) 2020 doo GmbH. All rights reserved.
//  https://scanbot.io/sdk
//

import Foundation
import ScanbotBarcodeScannerSDK

enum ScanbotSDKInitializer {    
    static func initialize(config: SDKInitializationConfig, result: @escaping FlutterResult) {
        if (!config.licenseCode.isEmpty) {
            ScanbotSDK.setLicense(config.licenseCode)
        }
        ScanbotSDK.setLoggingEnabled(config.isLoggingEnabled)
        
        if let encrypter = config.defaultEncrypter {
            ScanbotSDKUI.setDefaultImageStoreEncrypter(encrypter)
            ScanbotSDKUI.setDefaultPDFEncrypter(encrypter)
        }
        
        SBSDKUIBarcodeImageStorage.setBaseStorageURL(config.storageBaseDirectory)
        
        result(nil)
    }
}
